% E58 Final Project Code
% Julian Leland
% E58, Swarthmore College
%% Create Values
k1 = -631;
k2 = 1.652e006;
k3 = 6.217e005;
k4 = -8.502e005;
k5 = 751.2;
k6 = -292.4;
k7 = 7.656e005;
k8 = 6.512e005;
k9 = -2.314e006;
k10 = 348.1;
k11 = -1.275e-008;
k12 = 7.0562e-006;
k13 = 2e-008;
k14 = -1.275e-008;
k15 = 7.0562e-006;
k16 = 1.3e-008;
Ds = 6.16;
Dz = 500;
Ms = 61.6;
Mz = 500;
rs = .05;
Rs = .2945;
rz = .001347;
Rz = 3;
Ls = 8.54e-003;
Lz = .08;
es = 28.96;
ez = 1.42;
ks = .5765;
kz = 1.25;

%% Values for no cutting
k1 = 0;
k2 = 0;
k3 = 6.217e005;
k4 = -8.502e005;
k5 = 0;
k6 = 0;
k7 = 0;
k8 = 6.512e005;
k9 = -2.314e006;
k10 = 0;
k11 = -1.275e-008;
k12 = 7.0562e-006;
k13 = 2e-008;
k14 = -1.275e-008;
k15 = 7.0562e-006;
k16 = 1.3e-008;

%% Plot velocity data
clf;
plot(ScopeData.time, ScopeData.signals.values(:,1).*.01,ScopeData.time,...
    ScopeData.signals.values(:,2),ScopeData.time,...
    ScopeData.signals.values(:,3).*1000,ScopeData.time,...
    ScopeData.signals.values(:,4))

%% Reduce cutting and feed force
RCf = 8; % Factor to reduce cutting force by
k1 = k1/RCf;
k2 = k2/RCf;
k3 = k3/RCf;
k4 = k4/RCf;
k5 = k5/RCf;

%% Plot rotation, Z distance traveled, and accumulated pitch error
clf;
hold on;
subplot(2,1,1);
[AX, H1, H2] = plotyy(ScopeData1.time, ScopeData1.signals.values(:,1),...
    ScopeData1.time, ScopeData1.signals.values(:,2));
set(get(AX(1),'Ylabel'),'String','Rotation, Rev');
set(get(AX(1),'Xlabel'),'String','Time');
set(get(AX(2),'Ylabel'),'String','Z Travel, inches');
MaxDist = max(ScopeData1.signals.values(:,2));
ylim(AX(2),[0, (MaxDist + .1*MaxDist)]);
subplot(2,1,2);
plot(ScopeData1.time, ScopeData1.signals.values(:,3))
%plot(ScopeData1.signals.values(:,1), ScopeData1.signals.values(:,3));
% This plots lead versus revolutions. If we look at two points on this
% plot, we can tell how much of a change in lead we've seen per revolution
% - this number should be under the allowable variation given by ASME B1.1
Xlabel('Rotation, Rev');
YLabel('Lead, inches');

%% Calculate maximum and average pitch deviation
RevSize = size(ScopeData1.signals.values(:,1));
j = 1;
RevB = 0;
% This loop picks out every revolution that the lathe spindle goes through
% and stores the locations of those whole revolutions in variable
% Revolutions.
for i = 1:RevSize(1)
    RevA = ScopeData1.signals.values(i,1);
    if RevA >= RevB + 1
        Revolutions(j) = i;
        j = j+1;
        RevB = RevA;
    end
end
% This loop pulls all the values of radial position and lead
% (position/revolution) at each whole revolution into the vector Points.
Ksize = size(Revolutions);
for k = 1:Ksize(2);
    Points(k,:) = [ScopeData1.signals.values(Revolutions(k),1),...
        ScopeData1.signals.values(Revolutions(k),3)];
end
% This loop calculates pitch error per revolution IF the pitch error at
% that point is non-zero.
for l = 1:(k-1)
    if Points(l,2) ~= 0
        PitchError(l) = (Points(l+1,2)-Points(l,2))/(Points(l+1,1)-...
            Points(l,1));
% Dividing by rotational change accounts for imperfections in simulation -
% simulation data does not include every whole rotation
    end
end
MaxPitchError = max(PitchError)
AvgPitchError = mean(PitchError)

%% Approximate TPI Calculation
Ksize = size(Revolutions);
for k = 1:Ksize(2);
    PositionPoints(k,:) = [ScopeData1.signals.values(Revolutions(k),1),...
        ScopeData1.signals.values(Revolutions(k),2)];
end
for l = 1:k
    if PositionPoints(l,2) ~= 0
        CutStart = l;
        break;
    end
end
AppxTPI = (PositionPoints(k,1) - PositionPoints(CutStart,1))/(PositionPoints(k,2) - PositionPoints(CutStart,2))